#ifndef THREAD
#define THREAD
#include <setjmp.h>
#include <assert.h>
#include <stdio.h>

typedef struct {
	jmp_buf	exec;
	jmp_buf	jump;
	jmp_buf	exit;
	int		parent;
	int	nchildren;
	int		free;
	int		next;
	char	*stack;
} thread;

extern thread	*Threads;
extern int		ThCurr;

#define ThProbe() { char p; assert(Threads[ThCurr].stack < &p); }

#define ThId()	ThCurr

thread *ThInit();
void ThFree();
int	ThNew();
int	ThJump();
void ThExit();
#endif
